Logo Search packages:      
Sourcecode: netams version File versions  Download package

netams.init.d

#!/bin/sh
#
# $Id$
#
# Copyright (c) 2007 Javier Fernandez-Sanguino <jfs@debian.org>
# Copyright (c) 2008 Alexander GQ Gerasiov <gq@cs.msu.su>
#
# This is free software; you may redistribute it and/or modify
# it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 2,
# or (at your option) any later version.
#
# This is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License with
# the Debian operating system, in /usr/share/common-licenses/GPL;  if
# not, write to the Free Software Foundation, Inc., 59 Temple Place,
# Suite 330, Boston, MA 02111-1307 USA
#
### BEGIN INIT INFO
# Provides:          netams
# Required-Start:    $network $local_fs
# Required-Stop:
# Should-Start:      $named
# Should-Stop:
# Default-Start:     2 3 4 5
# Default-Stop:      0 1 6
# Short-Description: Network Traffic Accounting and Monitoring Software
# Description:        NeTAMS stands for Network Traffic Accounting and Monitoring Software.
#                     It is built for UNIX and works for networks with Cisco routers or PC
#                     Unix routers (Linux/FreeBSD/Solaris). Several methods of traffic
#                     gathering are supported (tee/divert/ip_queue/libpcap/ulog/netflow v5
#                     and v9/netgraph), database storage (BerkleyDB/MySQL/PostgresSQL/
#                     Oracle/Radius), aggregation, visualization, notification etc. It is
#                     possible to block traffic based on quotas, web authorization, account
#                     balance (billing); manage bandwidth, MAC assignmant violations, RADIUS
#                     services, create a flexible accounting and filtering policies.
### END INIT INFO

PATH=/usr/local/sbin:/usr/local/bin:/sbin:/bin:/usr/sbin:/usr/bin

DAEMON=/usr/sbin/netams
NAME=netams
DESC="NeTAMS daemon"
LOGDIR=/var/log/netams

PIDFILE=/var/run/$NAME.pid

test -x $DAEMON || exit 0

. /lib/lsb/init-functions

# Default options, these can be overriden by the information
# at /etc/default/$NAME
DAEMON_OPTS=""          # Additional options given to the server

DIETIME=10              # Time to wait for the server to die, in seconds
                        # If this value is set too low you might not
                        # let some servers to die gracefully and
                        # 'restart' will not work

LOGFILE=$LOGDIR/$NAME.log  # Server logfile

# Include defaults if available
if [ -f /etc/default/$NAME ] ; then
      . /etc/default/$NAME
fi

# Use this if you want the user to explicitly set 'RUN' in
# /etc/default/
if [ "x$RUN" != "xyes" ] ; then
    log_warning_msg "$NAME disabled, please adjust the configuration to your needs "
    log_warning_msg "and then set RUN to 'yes' in /etc/default/$NAME to enable it."
    exit 0
fi


set -e

running_pid() {
# Check if a given process pid's cmdline matches a given name
    pid=$1
    name=$2
    [ -z "$pid" ] && return 1
    [ ! -d /proc/$pid ] &&  return 1
    cmd=`cat /proc/$pid/cmdline | tr "\000" "\n"|head -n 1 |cut -d : -f 1`
    # Is this the expected server
    [ "$cmd" != "$name" ] &&  return 1
    return 0
}

running() {
# Check if the process is running looking at /proc
# (works for all users)

    # No pidfile, probably no daemon present
    [ ! -f "$PIDFILE" ] && return 1
    pid=`cat $PIDFILE`
    running_pid $pid $DAEMON || return 1
    return 0
}

start_server() {
# Start the process using the wrapper
    start_daemon -p $PIDFILE $DAEMON $DAEMON_OPTS
}

stop_server() {
# Stop the process using the wrapper
    killproc -p $PIDFILE $DAEMON
}

reload_server() {
    [ ! -f "$PIDFILE" ] && return 1
    pid=`pidofproc -p $PIDFILE $DAEMON` # This is the daemon's pid
    # Send a SIGHUP
    kill -1 $pid
    return $?
}

reopen_logs() {
    [ ! -f "$PIDFILE" ] && return 1
    pid=`pidofproc -p $PIDFILE $DAEMON` # This is the daemon's pid
    # Send a SIGUSR1
    kill -s USR1 $pid
    return $?
}

force_stop() {
# Force the process to die killing it manually
      [ ! -e "$PIDFILE" ] && return
      if running ; then
            kill -15 $pid
      # Is it really dead?
            sleep "$DIETIME"s
            if running ; then
                  kill -9 $pid
                  sleep "$DIETIME"s
                  if running ; then
                        echo "Cannot kill $NAME (pid=$pid)!"
                        exit 1
                  fi
            fi
      fi
      rm -f $PIDFILE
}


case "$1" in
  start)
      log_daemon_msg "Starting $DESC" "$NAME"
        # Check if it's running first
        if running ;  then
            log_progress_msg "apparently already running"
            log_end_msg 0
            exit 0
        fi
        if start_server && running ; then
            # It's ok, the server started and is running
            log_end_msg 0
        else
            # Either we could not start it or it doesn't running
            log_end_msg 1
        fi
      ;;
  stop)
        log_daemon_msg "Stopping $DESC" "$NAME"
        if running ; then
            # Only stop the server if we see it running
                  errcode=0
            stop_server || errcode=$?
            log_end_msg $errcode
        else
            # If it's not running don't do anything
            log_progress_msg "apparently not running"
            log_end_msg 0
            exit 0
        fi
        ;;
  force-stop)
        # First try to stop gracefully the program
        $0 stop
        if running; then
+            # If it's still running try to kill it more forcefully
            log_daemon_msg "Stopping (force) $DESC" "$NAME"
                  errcode=0
            force_stop || errcode=$?
            log_end_msg $errcode
        fi
      ;;
  restart|force-reload)
        log_daemon_msg "Restarting $DESC" "$NAME"
            errcode=0
        stop_server || errcode=$?
        # Wait some sensible amount, some server need this
        [ -n "$DIETIME" ] && sleep $DIETIME
        start_server || errcode=$?
        [ -n "$STARTTIME" ] && sleep $STARTTIME
        running || errcode=$?
        log_end_msg $errcode
      ;;
  status)

        log_daemon_msg "Checking status of $DESC" "$NAME"
        if running ;  then
            log_progress_msg "running"
            log_end_msg 0
        else
            log_progress_msg "apparently not running"
            log_end_msg 1
            exit 1
        fi
        ;;
  # Use this if the daemon cannot reload
  reload)
        log_warning_msg "Reloading $NAME daemon: not implemented, as the daemon"
        log_warning_msg "cannot re-read the config file (use restart)."
        ;;
  # And this if it cann
  #reload)
          #
          # If the daemon can reload its config files on the fly
          # for example by sending it SIGHUP, do it here.
          #
          # If the daemon responds to changes in its config file
          # directly anyway, make this a do-nothing entry.
          #
          # log_daemon_msg "Reloading $DESC configuration files" "$NAME"
          # if running ; then
          #    reload_server
          #    if ! running ;  then
          # Process died after we tried to reload
          #       log_progress_msg "died on reload"
          #       log_end_msg 1
          #       exit 1
          #    fi
          # else
          #    log_progress_msg "server is not running"
          #    log_end_msg 1
          #    exit 1
+          # fi
+                                                                                    #;;
+  reopen-logs)
+     if ! running ; then
+         log_warning_msg "$NAME daemon is not running"
+         exit 0
+     fi
+
+     log_daemon_msg "Reopening $NAME log files" "$NAME"
+     reopen_logs
+     if ! running ; then
+         log_progress_msg "died on log reopen"
+         log_end_msg 1
+         exit 1
+     fi
+     ;;
+
+  *)
+     N=/etc/init.d/$NAME
+     echo "Usage: $N {start|stop|force-stop|restart|force-reload|status|reopen-logs}" >&2
+     exit 1
+     ;;
+esac
+
+exit 0

Generated by  Doxygen 1.6.0   Back to index